<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Tim Lochmller <tim@fruit-lab.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Extended SEO Sitemap' for the 'fl_seo_sitemap' extension.
 *
 * @author   Tim Lochmller <tim@fruit-lab.de>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_flseositemap_pi1 extends tslib_pibase {

   var $prefixId = 'tx_flseositemap_pi1';
   var $scriptRelPath = 'pi1/class.tx_flseositemap_pi1.php';
   var $extKey = 'fl_seo_sitemap';
   var $pi_checkCHash = true;
   
   // function - main
   function main($content,$conf){
   
      // Loaddata
      $conf['ext']['base'] = $this->my_getFFvalue('base', true);
      $conf['ext']['deep'] = $this->my_getFFvalue('deep', true);
      $conf['ext']['link_open_in'] = $this->my_getFFvalue('link_open_in', true);
      $conf['ext']['seperator'] = $this->my_getFFvalue('seperator', true);
      $conf['ext']['output_type'] = $this->my_getFFvalue('output_type', true);
      $conf['ext']['show_pages'] = $this->my_getFFvalue('show_pages', true);
      $conf['ext']['beschreibung_field'] = $this->my_getFFvalue('beschreibung_field');
      $conf['ext']['link_field'] = $this->my_getFFvalue('link_field');
      //$conf['ext']['zusatz'] = $this->my_getFFvalue('zusatz');
      $conf['ext']['ignore'] = $this->my_getFFvalue('ignore');
   
      // Konfig
      $conf['ext']['CSS'] = (str_replace("_class","",$conf['ext']['output_type']) != $conf['ext']['output_type']);
      $conf['ext']['output_type'] = str_replace("_class","",$conf['ext']['output_type']);
      $conf['ext']['show_pages'] = $this->generateAddQueryPages($conf['ext']['show_pages']);
      $this->conf=$conf;
      $this->pi_setPiVarDefaults();
      $this->pi_loadLL();
      
      $content = $this->getListOfPages($this->conf['ext']['base']);
   
      return $this->pi_wrapInBaseClass($content);
   } // function
   
   // function - generateAddQueryPages
   function generateAddQueryPages($in){
   
      $std = '(`doktype`=1 AND `nav_hide`=0)';
      $std_nav = '(`doktype`=1 AND `nav_hide`=1)';
      $erw = '(`doktype`=2 AND `nav_hide`=0)';
      $erw_nav = '(`doktype`=2 AND `nav_hide`=1)';
      
      switch($in) {
         case 1: $out = $std; break;
         case 2: $out = $std_nav; break;
         case 3: $out = $std.' OR '.$std_nav; break;
         case 4: $out = $erw; break;
         case 5: $out = $erw.' OR '.$std; break;
         case 6: $out = $erw.' OR '.$std_nav; break;
         case 7: $out = $erw.' OR '.$std.' OR '.$std_nav; break;
         case 8: $out = $erw_nav; break;
         case 9: $out = $erw_nav.' OR '.$std; break;
         case 10: $out = $erw_nav.' OR '.$std_nav; break;
         case 11: $out = $erw_nav.' OR '.$std_nav.' OR '.$std; break;
         case 12: $out = $erw_nav.' OR '.$erw; break;
         case 13: $out = $erw_nav.' OR '.$std.' OR '.$erw; break;
         case 14: $out = $erw_nav.' OR '.$std_nav.' OR '.$erw; break;
         case 15: $out = $erw_nav.' OR '.$std.' OR '.$erw.' OR '.$std_nav; break;
         default: $out = ''; break;
      } // switch
      
      return $out;
   } // function
   
   // function - getListOfPages
   function getListOfPages($uid, $deep=0, $c = '',$end = false){
      // ignores abfangen
      if(in_array($uid, $this->conf['ext']['ignore']) or $deep == $this->conf['ext']['deep'] or $this->conf['ext']['show_pages'] == '') return;
      
      //echo $conf['ext']['show_pages'];
      
      $add = ' AND ('.$this->conf['ext']['show_pages'].')';
      $where = '`deleted`=0 AND `hidden`=0 AND  ((`starttime` < UNIX_TIMESTAMP()) AND (`endtime` > UNIX_TIMESTAMP() OR `endtime`=0)) AND `pid`='.$uid.$add;

      $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,description as beschreibung,abstract as inhaltsangabe,keywords as stichworte,fl_seo_sitemap_field as seo_sitemap,title as seitentitel,subtitle untertitel,nav_title as navigationstitel','pages', $where, 'sorting');
      while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){

         if($c == ''){
            if($this->conf['ext']['output_type'] == 'singlelist' AND $deep == 0)
               $c .= '<ul'.$this->css('list', 'deep_'.$deep).'>';
            elseif($this->conf['ext']['output_type'] == 'multilist')
               $c .= '<ul'.$this->css('list', 'deep_'.$deep).'>';
         } // if
         
         // Beschreibung
         $beschreibung = '';
         for($i = 0; $i < sizeof($this->conf['ext']['beschreibung_field']) AND $beschreibung == ''; $i++){
            if(trim($row[$this->conf['ext']['beschreibung_field'][$i]]) != '')
                $beschreibung = trim($row[$this->conf['ext']['beschreibung_field'][$i]]);
         } // for
         
         // Linktext
         $linktext = '';
         for($i = 0; $i < sizeof($this->conf['ext']['link_field']) AND $linktext == ''; $i++){
            if(trim($row[$this->conf['ext']['link_field'][$i]]) != '')
                $linktext = trim($row[$this->conf['ext']['link_field'][$i]]);
         } // for
         
         $outstr  = '<a href="'.$this->pi_getPageLink($row['uid']).'" target="'.$this->conf['ext']['link_open_in'].'">'.$linktext.'</a> '.$this->conf['ext']['seperator'].' '.$beschreibung."\n\r";


         $next = $this->getListOfPages($row['uid'],$deep+1);
         $c .= '<li'.$this->css('item', 'deep_'.$deep).'>'.$outstr.''.(($this->conf['ext']['output_type'] != 'singlelist')?$next:'').'</li>'.(($this->conf['ext']['output_type'] != 'singlelist')?'':$next);

         $end = true;
      } // while
      
      if((($this->conf['ext']['output_type'] == 'singlelist' AND $deep == 0) OR $this->conf['ext']['output_type'] == 'multilist') AND $end)
         $c .= '</ul>';

      return $c;
   } // function
   
   // function - css
   function css($s,$ss='') {
      return ($this->conf['ext']['CSS'])?' class="'.$this->extKey.'_'.$s.''.(($ss!='')?' '.$ss:'').'"':'';
   } // function
   
   // function - my_getFFvalue
   function my_getFFvalue($v,$first=false){
      if(!$this->my_FFLoad) $this->pi_initPIflexForm();
      $this->my_FFLoad = true;
      $var = explode(',',$this->pi_getFFvalue($this->cObj->data['pi_flexform'],$v,'sDEF'));
      return ($first)?$var[0]:$var;
   } // function

   // function - err
   function err($err){
      mail($this->errMail, 'Fehler in '.$this->extKey, $err);
      return '<div style="border:2px solid red; font-weight: bold; padding: 10px; background-color: #FF9999">'.$err.'</div>';
   } // function

   // function - debug
   function debug($a,$t='kein Titel') {
      t3lib_div::debug($a,$t);
   } // function
} // class

if(defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_seo_sitemap/pi1/class.tx_flseositemap_pi1.php']){
   include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fl_seo_sitemap/pi1/class.tx_flseositemap_pi1.php']);
} // if
?>